# Balazar
# Copyright (C) 2005 Jean-Baptiste LAMY
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import math
import soya
    
import balazar.base as base

from balazar.character import _P, _V
from balazar.sound     import play

class Vehicule:
  pass


class FlyingBoat(soya.Volume):
  def __init__(self, parent, advance = 1):
    soya.Volume.__init__(self, parent, soya.Shape.get("barque"))
    
    self.advance = advance
    self.speed = soya.Vector(self, 0.0, 0.0, -0.4)
    #self.rotate_incline(10.0)
    self.angle = 0.0
    
  def big_round(self):
    if not self.advance:
      for character in self.parent.characters.values():
        if character.ground and character.ground.parent is self:
          self.solid = 0
          if not self.get_root().raypick_b(self, self.speed, 0.5, 1, 0): self.advance = 1
          self.solid = 1
          break
        
  def begin_round(self):
    if self.advance:
      self.solid = 0
      if self.get_root().raypick_b(self, self.speed, 0.5, 1, 0):
        play("chute.wav", self, gain = 4.5)
        self.advance = 0
      self.solid = 1
      
  def advance_time(self, proportion):
    if self.advance:
      self.angle += 0.02 * proportion
      self.look_at_y(soya.Point(self.parent, self.x + math.cos(self.angle), self.y + 3.0, self.z + math.sin(self.angle)))
      self.add_mul_vector(proportion, self.speed)
      
